<template>
  <div id="register_wrapper">
    <el-container style="border : 0px solid;">
      <el-row style="left:10%; width:100%, height:100%;">
        <el-col style="width: 100%; border:0px solid;">
          <el-form :model="input" :rules="rules" ref="elForm" :label-width="getLabelWidth()">
            <el-form-item>
              <!--뒤로가기 추가-->
              <div style="display:inline; float: right; margin-top:17px">
                <a href="javascript:history.back();">
                 <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
                </a>
              </div>            
              <h2>{{ $t('REG.REG_TITLE') }}</h2>
            </el-form-item>

            <el-form-item :label="$t('REG.USER_TYPE_LABEL')" prop="type" id="type">
              <el-radio-group v-model="input.type" id="user_type_input">
                <el-radio-button label="0">{{ $t('REG.USER_TYPE_STU') }}</el-radio-button>
                <el-radio-button label="1">{{ $t('REG.USER_TYPE_INST') }}</el-radio-button>
                <!--el-radio-button label="2" disabled="true">{{ $t('REG.USER_TYPE_STUINST') }}</el-radio-button-->
              </el-radio-group>
            </el-form-item>

            <el-form-item :label="$t('REG.EMAIL_LABEL')" prop="email_id" id="email_id">
              <el-input :placeholder="$t('REG.EMAIL_PH')" v-model="input.email_id" type="email"></el-input>
            </el-form-item>

            <el-form-item :label="$t('REG.PASSWORD_LABEL')" prop="password" id="password">
              <el-input :placeholder="$t('LOGIN.PASSWORD_PH')" v-model="input.password" type="password"></el-input>
              <br> {{ $t('REG.PASSWORD_HELP1') }}
              <br> * {{ $t('REG.PASSWORD_HELP2') }}: !, @, #, $, %, &#38;, * <br>
            </el-form-item>

            <el-form-item :label="$t('REG.PASSWORD_CHECK_LABEL')" prop="password2" id="password2">
              <el-input :placeholder="$t('LOGIN.PASSWORD_PH')" v-model="input.password2" type="password"></el-input>
            </el-form-item>

            <el-form-item :label="$t('REG.NAME_LABEL')" prop="name" id="name">
              <el-input :placeholder="$t('REG.NAME_PH')" v-model="input.name" type="string">
              </el-input>
            </el-form-item>

            <el-form-item :label="$t('REG.SEX_LABEL')" prop="sex" id="sex">
              <el-radio-group v-model="input.sex" id="user_sex_input">
                <el-radio-button label="0">{{ $t('REG.SEX_LABEL_MALE') }}</el-radio-button>
                <el-radio-button label="1">{{ $t('REG.SEX_LABEL_FEMALE') }}</el-radio-button>
              </el-radio-group>
            </el-form-item>

            <el-form-item :label="$t('REG.BIRTHDAY_LABEL')" prop="birth" id="birth">
              <el-date-picker :placeholder="$t('REG.BIRTHDAY_PH')" v-model="input.birth" type="date" id="user_birthday_input">
              </el-date-picker>
            </el-form-item>

            <el-form-item :label="$t('REG.PHONE_NUMBER_LABEL')" prop="phone" id="phone">
              <el-input :placeholder="$t('REG.PHONE_NUMBER_PH')" v-model="input.phone" v-mask="['###-####-####', '###-###-####']" type="tel"></el-input>
              <!-- <el-button type="primary" @click="dummy()">{{$t('REG.PHONE_NUMBER_VERIFY_BUTTON')}}</el-button> -->
            </el-form-item>

            <!--
            <el-form-item :label="$t('REG.PHOTO_LABEL')" prop="photo" id="photo">
                  <input type="file" class="file_input_button" name="uploadFile" @change="doUpload"> </input>
              <input type="text" id="fileName" class="file_input_textbox" readonly="readonly">
              <div class="file_input_div">
                  <input type="file" class="file_input_button" name="uploadFile" @change="doUpload"> </input>
                <input type="button" value="파일선택" class="file_input_button">
                <input type="file" class="file_input_hidden" onchange="javascript:document.getElementById('fileName').value = this.value.split('\\')[this.value.split('\\').length-1]" v-on:change="processFile($event)">
              </div>
              * 파일명 : 학번 / 파일형식(jpg, png, gif)
            </el-form-item>
            -->
            <br />

            <el-form-item>
              <el-button style="width:250px; height:50px; background:navy; border:0px; font-weight:700;" id="btn_submit_register" type="primary" @click="submitForm('elForm')">회원가입</el-button>
            </el-form-item>
            <br />

          </el-form>
        </el-col>
      </el-row>
    </el-container>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import generateRules from '../../validations/registerValidation';
import authService from '../../services/authService';
import lectureService from '../../services/lectureService';
import http from '../../services/lectureService';
import userService from '../../services/userService';

export default {
  directives: { focus },
  name: 'Register',
  data() {
    const vm = this;
    return {
      focused: false,
      input: {
        type: '0',
        email_id: '',
        password: '',
        password2: '',
        name: '',
        birth: '',
        postcode: '',
        address1: '', // 지역 주소
        address2: '', // 상세 주소
        phone: '',
        major: '',
        belong: '',
        sex: '0',
        dialogImageUrl: '',
        dialogVisible: false,
        fileData:''
      },
      rules: generateRules(vm),
    };
  },
  computed: {
    ...mapState('auth', ['locale']),
    address() {
      const vm = this;
      const address = `${vm.input.address1} ${vm.input.address2} ${vm.input.postcode}`;
      return address.trim();
    },
  },
  methods: {
    processFile(event) {
      this.fileData = event.target.files[0];
    },
    // doUpload(req) {
    //   const file = req.file;
    //   let form = new FormData();
    //
    //   form.append('uploadFile', file);
    //   form.append('email_id', this.input.email_id);
    //
    //   var api = "http://localhost:8010/users/upload";
    //
    //   axios
    //   .post(api, form)
    //   .then(response => {
    //
    //   })
    //   .catch(err => {
    //     console.log(err);
    //   });
    //
    // },

    async doUpload() {
      const form = new FormData();
      form.append('uploadFile', this.fileData);
      form.append('email_id', this.input.email_id);
      // await userService.postUserProfile(form);
    },
    handleRemove(file, fileList) {
      // console.log(file, fileList);
    },
    handlePictureCardPreview(file) {
      this.dialogImageUrl = file.url;
      this.dialogVisible = true;
    },
    execDaumPostcode() {
      const vm = this;
      new window.daum.Postcode({
        // 팝업에서 검색결과 항목을 클릭했을때 실행할 코드를 작성하는 부분.
        oncomplete(data) {
          // 각 주소의 노출 규칙에 따라 주소를 조합한다.
          // 내려오는 변수가 값이 없는 경우엔 공백('')값을 가지므로, 이를 참고하여 분기 한다.
          let fullAddr = ''; // 최종 주소 변수
          let extraAddr = ''; // 조합형 주소 변수

          // 사용자가 선택한 주소 타입에 따라 해당 주소 값을 가져온다.
          if (data.userSelectedType === 'R') {
            // 사용자가 도로명 주소를 선택했을 경우
            fullAddr = data.roadAddress;
          } else {
            // 사용자가 지번 주소를 선택했을 경우(J)
            fullAddr = data.jibunAddress;
          }

          // 사용자가 선택한 주소가 도로명 타입일때 조합한다.
          if (data.userSelectedType === 'R') {
            // 법정동명이 있을 경우 추가한다.
            if (data.bname !== '') {
              extraAddr += data.bname;
            }
            // 건물명이 있을 경우 추가한다.
            if (data.buildingName !== '') {
              extraAddr +=
                extraAddr !== '' ? `, ${data.buildingName}` : data.buildingName;
            }
            // 조합형주소의 유무에 따라 양쪽에 괄호를 추가하여 최종 주소를 만든다.
            fullAddr += extraAddr !== '' ? ` (${extraAddr})` : '';
          }

          // 우편번호와 주소 정보를 해당 필드에 넣는다.
          vm.input.postcode = data.zonecode; // 5자리 새우편번호 사용
          vm.input.address1 = fullAddr;

          // 커서를 상세주소 필드로 이동한다.
          document.getElementById('detail').focus();
        },
      }).open();
    },
    validator(formName, element) {
      const vm = this;
      let isValid = true;
      vm.$refs[formName].validateField(element, async (e) => {
        if (e) {
          vm.$scrollTo('#' + element, 500, { // eslint-disable-line
            offset: -100,
          });
          // window.console.log(e);
          isValid = false;
        }
      });
      return isValid;
    },
    async submitForm(formName) {

      // this.doUpload2();

      const vm = this;

      // if (vm.$isProd) {
      //   vm.$notify({
      //     message: 'ㅎㅎ! 막아놨음',
      //   });
      //   return;
      // }
      const fieldList = [
        'type',
        'email_id',
        'password',
        'password2',
        'name',
        'birth',
        'sex',
        // 'address1',
        // 'address2',
        // 'phone',
        // 'major',
        // 'belong',
      ];

      let allValid = true;
      for (let i = 0; i < fieldList.length; i += 1) {
        if (!vm.validator(formName, fieldList[i])) {
          allValid = false;
          break;
        }
      }

      if (!allValid) {
        console.log('error submit!!'); // eslint-disable-line
        return;
      }
      try {
        if (vm.input.birth === '') {
          vm.input.birth = null
        }
        const res = await authService.register({
          input: {
            ...vm.input, address: vm.address,
          },
        });
        // await this.doUpload();
        vm.$router.push({ // LandingPage로 redirect
          name: 'LandingPage',
        });
      } catch (e) {        
        if (e.message === 'Request failed with status code 409') {
          vm.$notify({
            title: '이메일 중복',
            message: '중복된 이메일입니다.',
            type: 'error',
            duration: 1000,
          });
        } else {
          throw new Error('request error');
        }
      }
    },
    getLabelWidth() {
      const vm = this;
      const labelString = [
        vm.$t('REG.EMAIL_LABEL'),
        vm.$t('REG.PASSWORD_LABEL'),
        vm.$t('REG.PASSWORD_CHECK_LABEL'),
        vm.$t('REG.NAME_LABEL'),
        vm.$t('REG.BIRTHDAY_LABEL'),
        vm.$t('REG.SEX_LABEL'),
        vm.$t('REG.ADDRESS_LABEL'),
        vm.$t('REG.ADDRESS2_LABEL'),
        vm.$t('REG.PHONE_NUMBER_LABEL'),
        vm.$t('REG.MAJOR_LABEL'),
        vm.$t('REG.BELONG_LABEL'),
        vm.$t('REG.TOU'),
      ];
      const maxLabelLength = Math.max.apply(null, labelString.map(x => x.length)) + 5;

      let charPixel = 15;
      switch (vm.locale) {
        default:
        case 'ko':
          charPixel = 15;
          break;
        case 'en':
          charPixel = 8;
          break;
      }
      const width = maxLabelLength * charPixel + 'px' // eslint-disable-line
      // window.console.log(width);

      return width;
    },
  },
};
</script>

<style lang="scss" scoped>
.el-input {
  width: 400px;
}

.el-button {
  margin-left: 10px;
}

.tos {
  background-color: white;
  border-radius: 4px;
  padding: 10px;
}

.file_input_textbox{float:left; height:35px; width:200px; border : 1px solid lightgrey; border-radius: 5px;}
.file_input_div{position:relative;width:100px;height:40px;overflow:hidden;}
.file_input_button{width:100px;height:40px;position:absolute; top:0px; background-color:#2497D8; color:#fff; border-style:solid;  border-radius: 5px;}
.file_input_hidden{
  font-size:50px;
  margin-left:5px;
  position:absolute;
  right:0px;
  top:0px;
  opacity:0;
  filter:alpha(opacity=0);
  -ms-filter:"alpha(opacity=0)";
  -khtml-opacity:0;
  -moz-opacity:0;
}


</style>
